VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form frmMotorControl 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Friction Lab - Motor Control"
   ClientHeight    =   5085
   ClientLeft      =   150
   ClientTop       =   720
   ClientWidth     =   6255
   Icon            =   "frmMotorControl.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   5085
   ScaleWidth      =   6255
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton btnUp 
      Caption         =   "Up"
      Height          =   372
      Left            =   5040
      TabIndex        =   5
      ToolTipText     =   "Move ramp up"
      Top             =   600
      Width           =   852
   End
   Begin VB.Frame frmSettings 
      Caption         =   "Motor Settings"
      Height          =   2532
      Left            =   240
      TabIndex        =   15
      Top             =   120
      Width           =   4452
      Begin VB.HScrollBar hscrollVel 
         Height          =   252
         Left            =   1800
         Max             =   10
         TabIndex        =   3
         Top             =   1560
         Value           =   5
         Width           =   1572
      End
      Begin VB.HScrollBar hscrollAccel 
         Height          =   252
         Left            =   1800
         Max             =   10
         TabIndex        =   2
         Top             =   1080
         Value           =   5
         Width           =   1572
      End
      Begin VB.HScrollBar hscrollDist 
         Height          =   252
         Left            =   1800
         Max             =   30000
         TabIndex        =   4
         Top             =   2040
         Width           =   1572
      End
      Begin VB.OptionButton optMC 
         Caption         =   "Continuous Mode (resets counter)"
         Height          =   252
         Left            =   1200
         TabIndex        =   1
         ToolTipText     =   "Motor moves continously until Stop button pressed"
         Top             =   600
         Width           =   3135
      End
      Begin VB.OptionButton optMN 
         Caption         =   "Normal Mode"
         Height          =   252
         Left            =   1200
         TabIndex        =   0
         ToolTipText     =   "Motor moves a set distance"
         Top             =   240
         Value           =   -1  'True
         Width           =   3135
      End
      Begin VB.Label lblVel 
         Alignment       =   1  'Right Justify
         Caption         =   "Velocity (rps)"
         Height          =   252
         Left            =   600
         TabIndex        =   21
         ToolTipText     =   "Adjust velocity of motor (rps)"
         Top             =   1560
         Width           =   972
      End
      Begin VB.Label lblVelValue 
         Alignment       =   1  'Right Justify
         Caption         =   "0"
         Height          =   252
         Left            =   3720
         TabIndex        =   20
         ToolTipText     =   "Value of velocity of motor (rps)"
         Top             =   1560
         Width           =   492
      End
      Begin VB.Label lblAccel 
         Alignment       =   1  'Right Justify
         Caption         =   "Acceleration (rps^2)"
         Height          =   252
         Left            =   120
         TabIndex        =   19
         ToolTipText     =   "Adjust acceleration of motor (rps^2)"
         Top             =   1080
         Width           =   1452
      End
      Begin VB.Label lblAccelValue 
         Alignment       =   1  'Right Justify
         Caption         =   "0"
         Height          =   252
         Left            =   3720
         TabIndex        =   18
         ToolTipText     =   "Value of acceleration of motor (rps^2)"
         Top             =   1080
         Width           =   492
      End
      Begin VB.Label lblDist 
         Alignment       =   1  'Right Justify
         Caption         =   "Distance (rotations)"
         Height          =   252
         Left            =   120
         TabIndex        =   17
         ToolTipText     =   "Adjust distance for motor to move (rotations)"
         Top             =   2040
         Width           =   1452
      End
      Begin VB.Label lblDistValue 
         Alignment       =   1  'Right Justify
         Caption         =   "30000"
         Height          =   252
         Left            =   3720
         TabIndex        =   16
         ToolTipText     =   "Value of distance for motor to move (rotations)"
         Top             =   2040
         Width           =   492
      End
   End
   Begin VB.Frame frmCalib 
      Caption         =   "Step Accumulator"
      Height          =   1212
      Left            =   240
      TabIndex        =   12
      Top             =   2880
      Width           =   2772
      Begin VB.CommandButton btnCalibReset 
         Caption         =   "Reset"
         Height          =   372
         Left            =   240
         TabIndex        =   8
         Top             =   600
         Width           =   852
      End
      Begin VB.Label lblStepValue 
         Alignment       =   1  'Right Justify
         Caption         =   "0"
         Height          =   252
         Left            =   1440
         TabIndex        =   14
         Top             =   720
         Width           =   852
      End
      Begin VB.Label lblStep 
         Caption         =   "Step Counter"
         Height          =   252
         Left            =   1440
         TabIndex        =   13
         Top             =   240
         Width           =   972
      End
   End
   Begin VB.CommandButton btnStop 
      Caption         =   "Stop"
      Height          =   372
      Left            =   5040
      TabIndex        =   7
      ToolTipText     =   "Stop motor immediately"
      Top             =   1800
      Width           =   852
   End
   Begin VB.CommandButton btnDown 
      Caption         =   "Down"
      Height          =   372
      Left            =   5040
      TabIndex        =   6
      ToolTipText     =   "Move ramp down"
      Top             =   1200
      Width           =   852
   End
   Begin VB.ComboBox cmbCommand 
      Height          =   315
      Left            =   240
      TabIndex        =   9
      ToolTipText     =   "Type or select motor commands here"
      Top             =   4560
      Width           =   3675
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   5040
      Top             =   0
      _ExtentX        =   794
      _ExtentY        =   794
      _Version        =   393216
      DTREnable       =   -1  'True
   End
   Begin VB.CommandButton btnSend 
      Caption         =   "Send"
      Default         =   -1  'True
      Height          =   315
      Left            =   3960
      TabIndex        =   11
      ToolTipText     =   "Send the command to the motor"
      Top             =   4560
      Width           =   735
   End
   Begin VB.Label lblCommand 
      Caption         =   "Enter manual motor commands here:"
      Height          =   255
      Left            =   240
      TabIndex        =   10
      Top             =   4320
      Width           =   3615
   End
   Begin VB.Menu mnuFile 
      Caption         =   "File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "Exit"
         Shortcut        =   ^C
      End
   End
   Begin VB.Menu mnuTools 
      Caption         =   "Tools"
      Index           =   0
      Begin VB.Menu mnuToolsCalc 
         Caption         =   "Friction Calculator"
         Shortcut        =   {F2}
      End
   End
   Begin VB.Menu mnuOptions 
      Caption         =   "Options"
      Begin VB.Menu mnuOptionsPort 
         Caption         =   "Port Properties..."
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "Help"
      NegotiatePosition=   3  'Right
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "About Friction Lab..."
      End
   End
End
Attribute VB_Name = "frmMotorControl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Elaine Cheong
'01 December 1999
'ENME414
'Team 2: Friction Apparatus

'Main window (motor control and commands)

Option Explicit                 'force explicit declaration of all variables in this module
Dim modeMotor As String         'stores mode of motor (normal or continuous)
Dim stepcount As Long           'stores accumulated steps (motor rotations)

Public Sub subStepUpdate(stepincr As Long)
    'Update value and display of stepcount
    stepcount = stepcount + stepincr
    lblStepValue = Str(stepcount)
End Sub

Public Sub subStepReset()
    'Reset value and display of stepcount
    stepcount = 0
    lblStepValue = Str(stepcount)
End Sub

Private Sub btnCalibReset_Click()
    'Reset value and display of stepcount
    Call subStepReset
End Sub

Private Sub btnDown_Click()
    'Commands to send to motor
    MSComm1.Output = "LD0" & vbCr                       'enable CCW and CW limits
    MSComm1.Output = "A" & hscrollAccel.Value & vbCr    'set acceleration
    MSComm1.Output = "V" & hscrollVel.Value & vbCr      'set velocity
    MSComm1.Output = "D-" & hscrollDist.Value & vbCr    'set travel distance
    MSComm1.Output = modeMotor & vbCr                   'set continuous or normal mode
    MSComm1.Output = "G" & vbCr                         'execute the move (go!)
    Call subStepUpdate(hscrollDist.Value * -1)          'update stepcount
End Sub

Private Sub btnStop_Click()
    MSComm1.Output = "S" & vbCr                         'stop the motor
    Call subStepReset                                   'reset stepcount
End Sub

Private Sub btnUp_Click()
    'Commands to send to motor
    MSComm1.Output = "LD0" & vbCr                       'enable CCW and CW limits
    MSComm1.Output = "A" & hscrollAccel.Value & vbCr    'set acceleration
    MSComm1.Output = "V" & hscrollVel.Value & vbCr      'set velocity
    MSComm1.Output = "D" & hscrollDist.Value & vbCr     'set travel distance
    MSComm1.Output = modeMotor & vbCr                   'set continuous or normal mode
    MSComm1.Output = "G" & vbCr                         'execute the move (go!)
    Call subStepUpdate(hscrollDist.Value)               'update stepcount
End Sub

Private Sub btnSend_Click()
    'Send contents of the combo box out the RS-232 port
    MSComm1.Output = cmbCommand.Text & vbCr
    
    'Clear combo box
    cmbCommand.Text = ""
End Sub

Private Sub Form_Load()
    'Set motor in normal mode as default (not continuous)
    modeMotor = "MN"
 
    'Initialize velocity scroll bar.
    hscrollVel.Min = 0
    hscrollVel.Max = 10
    hscrollVel.LargeChange = 2
    hscrollVel.SmallChange = 1
    hscrollVel.Value = 5
    lblVelValue.Caption = hscrollVel.Value
    
    'Initialize acceleration scroll bar.
    hscrollAccel.Min = 0
    hscrollAccel.Max = 10
    hscrollAccel.LargeChange = 2
    hscrollAccel.SmallChange = 1
    hscrollAccel.Value = 5
    lblAccelValue.Caption = hscrollAccel.Value
    
    'Initialize distance scroll bar.
    hscrollDist.Min = 0
    hscrollDist.Max = 30000
    hscrollDist.LargeChange = 1000
    hscrollDist.SmallChange = 20
    hscrollDist.Value = 10000
    lblDistValue.Caption = hscrollDist.Value

    'Set up the MSComm control (for serial communications)
    With MSComm1
        .CommPort = 1
        .Settings = "9600,N,8,1"
        .PortOpen = True
        .RThreshold = 1
    End With
    
    'Fill the ComboBox with motor commands for convenience.
    With cmbCommand
        .AddItem "v10"                  'set velocity to 10rpm
        .AddItem "g"                    'execute the move (go!)
        .AddItem "s"                    'stop the motor
    End With
End Sub

Private Sub hscrollVel_Change()
    'Update the displayed velocity when the scroll bar is changed
    lblVelValue.Caption = hscrollVel.Value
End Sub

Private Sub hscrollVel_Scroll()
    'Update the displayed velocity when user moves the scroll bar
    '(but does not let go of the scroll bar yet)
    lblVelValue.Caption = hscrollVel.Value
End Sub
Private Sub hscrollAccel_Change()
    'Update the displayed accel when the scroll bar is changed
    lblAccelValue.Caption = hscrollAccel.Value
End Sub

Private Sub hscrollAccel_Scroll()
    'Update the displayed accel when user moves the scroll bar
    '(but does not let go of the scroll bar yet)
    lblAccelValue.Caption = hscrollAccel.Value
End Sub
Private Sub hscrollDist_Change()
    'Update the displayed distance when the scroll bar is changed
    lblDistValue.Caption = hscrollDist.Value
End Sub

Private Sub hscrollDist_Scroll()
    'Update the displayed distance when user moves the scroll bar
    '(but does not let go of the scroll bar yet)
    lblDistValue.Caption = hscrollDist.Value
End Sub

Private Sub mnuFileExit_Click()
    'Confirm quit with a dialog box (Display Warning Query icon, OK, and Cancel buttons)
    Dim tempok
    tempok = MsgBox("OK to quit?", vbQuestion + vbOKCancel, "Confirm Exit")
    If (tempok = vbOK) Then
        Unload frmCalculate
        Unload Me
    End If
End Sub

Private Sub mnuHelpAbout_Click()
    'Display the About... form as a modal (dependent) dialog box.
    frmAbout.Show vbModal
End Sub

Private Sub mnuOptionsPort_Click()
    'Show the CommPort properties form as a modal (dependent) dialog box.
    frmProperties.Show vbModal
End Sub

Private Sub mnuToolsCalc_Click()
    'Display the Friction Calculator tool as a modeless (independent) window.
    frmCalculate.Show vbModeless
End Sub

Private Sub MSComm1_OnComm()
    'Serial communications control.
    'Branch according to the CommEvent property.
    'Only pay attention to Receive messages here.
    Select Case MSComm1.CommEvent
        'Respond to a Receive Event.
        Case comEvReceive
            Dim Buffer As Variant       'Declare Buffer variable
            Buffer = MSComm1.Input      'Get Input
            'Place input in debug window
            Debug.Print "Receive - " & StrConv(Buffer, vbUnicode)
        'We could also respond to a Send Event.
        'Case comEvSend
    End Select
End Sub

Private Sub optMC_Click()
    'Set continuous mode
    modeMotor = "MC"                'store continuous mode
    hscrollDist.Enabled = False     'disable distance scrobllbar
    lblDist.Enabled = False         'disable distance label
    lblDistValue.Enabled = False    'disable distance value
    frmCalib.Enabled = False        'disable calibration frame
    btnCalibReset.Enabled = False   'disable calibration button
    lblStep.Enabled = False         'disable step label
    lblStepValue.Enabled = False    'disable step value
    Call subStepReset               'reset stepcount
End Sub

Private Sub optMN_Click()
    'Set normal mode
    modeMotor = "MN"                'store normal mode
    hscrollDist.Enabled = True      'enable distance scrollbar
    lblDist.Enabled = True          'enable distance label
    lblDistValue.Enabled = True     'enable distance value
    frmCalib.Enabled = True         'enable calibration frame
    btnCalibReset.Enabled = True    'enable calibration button
    lblStep.Enabled = True          'enable step label
    lblStepValue.Enabled = True     'enable step value
    Call subStepReset               'reset stepcount
End Sub
